int  serial_init (void)
{
	/* inizializza seriale -- restituisce un puntatore alla porta seriale */
	sprintf(port, "/dev/ttyS0");
	fd_serial = open(port, O_RDWR | O_NOCTTY );
		if (fd_serial < 0) {
			fprintf (stderr, "Impossibile aprire la porta seriale ... \n");
			exit (-1);
		}
		return fd_serial;
}

void serial_close (int fd_serial)
{
	close (fd_serial);
}

void restore_serial (int fd_serial, struct termios *way_it_was)
{
	tcsetattr(fd_serial, TCSANOW, way_it_was);
}

void set_serial (int fd_serial, struct termios *options, struct termios *way_it_was)
{
	/* get current options for serial port */
	tcgetattr (fd_serial, options);
	tcgetattr (fd_serial, way_it_was);
	cfsetispeed (options, B9600);
	cfsetospeed (options, B9600);
	options->c_cflag |= (CLOCAL | CREAD);
	options->c_lflag |= (ICANON);
	options->c_lflag &= ~(ECHO | ECHOE);
	options->c_oflag &= ~(OPOST);
	options->c_cflag &= ~ (PARENB);
	options->c_cflag &= ~ (CSTOPB);
	options->c_cflag &= ~ (CSIZE);
	options->c_cflag |= (CS8);
	options->c_cflag &= ~ (HUPCL);
	tcflush (fd_serial,TCIFLUSH);
	tcsetattr (fd_serial, TCSANOW, options);
}

void set_serial_hi (int fd_serial, struct termios *options, struct termios *way_it_was)
{
	/* get current options for serial port */
	/* tcgetattr (fd_serial, options);
	cfsetispeed (options, B38400);
	cfsetospeed (options, B38400);
	tcflush (fd_serial,TCIFLUSH);
	tcsetattr (fd_serial, TCSANOW, options);*/
	tcgetattr (fd_serial, options);
	tcgetattr (fd_serial, way_it_was);
	cfsetispeed (options, B38400);
	cfsetospeed (options, B38400);
	options->c_cflag |= (CLOCAL | CREAD);
	options->c_lflag |= (ICANON);
	options->c_lflag &= ~(ECHO | ECHOE);
	options->c_oflag &= ~(OPOST);
	options->c_cflag &= ~ (PARENB);
	options->c_cflag &= ~ (CSTOPB);
	options->c_cflag &= ~ (CSIZE);
	options->c_cflag |= (CS8);
	options->c_cflag &= ~ (HUPCL);
	tcflush (fd_serial,TCIFLUSH);
	tcsetattr (fd_serial, TCSANOW, options);
	
}

void serial_out(int fd_serial, char *command_rx)
{
	/*  invia un comando al PCR 1000*/
	char tmp [64];
	sprintf (tmp, "%s%s",command_rx,"\n\r");
	write (fd_serial, tmp, strlen(tmp));
	return;
}

void get_level(int fd_serial)
{
	char string_send [4] = "I1?";
	char string_recv [6] ;
	char SMETER [20];
	char neddle;
	int nbytes = 0, level = 0,index = 0;
	int scale;
		
	string_recv [0]= '\0';
	write (fd_serial, string_send, strlen(string_send));
	nbytes = read(fd_serial, string_recv, 5 );
		if (string_recv [0]=='G') return; 
		if (nbytes < 5 ) return;
		string_recv [nbytes] = '\0';
		string_recv [0] =' ';
		string_recv [1] =' '; 
			level = (strtol (string_recv,NULL,16) );
			if (level < 64 ) 
			{
				scale = 4;
				neddle = '^';
			}
			else 
			{
				scale = 16;
				neddle = '*';
			}
			index=  (level / scale);
			strcpy(SMETER,"----------------");
			SMETER[index] = neddle;                     
			mvprintw (6,62,SMETER);
			tcflush (fd_serial,TCIFLUSH);
			refresh();
	return;
}

void PCR1000_init1 (int fd_serial)
{
	/* invia i seguenti comandi al PCR1000
	 * H101 turn radio on
	 * G300 autoupdate off
	 * G105 38400 bps
	 */
	char string [256];
	sprintf (string, "%s","H101\n\rG300\n\r");
	write (fd_serial,string,strlen(string));
}

